package org.olga.rebus.calculations;

/**
 * ,    .
 *   :     .
 * 
 * @author Olga
 *
 */
class ValuesGetter {
	//   
	private int[] myValues1;
	//   
	private int[] myValues2;
	//,      .
	private int[] myPattern = new int[10];
			
	/**
	 *  .
	 * 
	 * @param size1 -  ,   
	 * @param size2 -  ,  
	 */
	ValuesGetter(int size1, int size2) {
		myValues1 = new int[size1];
		for (int i = 0; i < size1; i++) {
			myValues1[i] = i;
		}
		myValues2 = new int[size2];
		if (size2 != 0) {
			myValues2[size2 - 1] = -1;
		}
	}
	
	/**
	 * ,      , 
	 *  .
	 * 
	 * @param index  
	 * @return 
	 */
	int getValue1(int index) {
		return myValues1[index];
	}
	
	/**
	 * ,      ,
	 *  .
	 * 
	 * @param index  
	 * @return 
	 */
	int getValue2(int index) {
		return myValues2[index];
	}
	
	/*
	 *  ,    
	 *  .
	 */
	private boolean next(int[] values) {
		int k = values.length - 1;
		if (k < 0) {
			return false;
		}
		if (values[k] == 9) {
			values[k] = 0;
			k--;
			while((k >= 0) && (values[k] == 9))  {
				values[k] = 0;
				k--;
			}
			
			if (k > -1) {
				values[k]++;
				return true;
			} else {
				return false;
			}
		} else {
			values[k]++;
			return true;
		}
	}
	
	/*
	 * ,      
	 * .
	 */
	private void initPattern() {
		for (int i=0; i < 10; i++) {
			myPattern[i] = 0;
		}
	}
	
	/*
	 * , ,      
	 * .
	 */
	private boolean isPattern() {
		this.initPattern();
		for (int i=0; i < myValues1.length; i++) {
			if (++myPattern[myValues1[i]] > 1) {
				return false;
			}
		}
		return true;
	}
	
	/*
	 * ,   , 
	 * .
	 */
	private boolean next1() {
		boolean f = this.next(myValues1);
		if (!f) {
			return false;
		}
		while(!this.isPattern()) {
			f = this.next(myValues1);
			if (!f) {
				return false;
			}
		}
		return f;
		
	}
	
	/*
	 * ,   , 
	 * .
	 */
	private boolean next2() {
		return next(myValues2);
	}
	
	/**
	 * ,    .
	 * 
	 * @return true,       
	 */
	boolean next() {
		if (!this.next2()) {
			for (int i=0; i < myValues2.length; i++) {
				myValues2[i] = 0;
			}
			if (myValues2.length > 0) {
				myValues2[myValues2.length - 1] = -1;
			}
			if (this.next1()) {
				this.next2();
			} else {
				return false;
			}
		}
		return true;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		for (int i=0; i < myValues1.length; i++) {
			sb.append(myValues1[i]);
		}
		return sb.toString();
	}
}
