package org.olga.rebus.structure;

/**
 *  -. 
 *   AbstractRelation.
 * 
 * @author Olga
 * @see AbstractRelation
 *
 */
public class MultiplyRelation extends AbstractRelation {

	/**
	 *  .
	 * 
	 * @param op1    .
	 * @param op2    .
	 * @param result    .
	 */
	MultiplyRelation(AbstractWord op1, 
			AbstractWord op2, AbstractWord result) {
		super(op1, op2, result);
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String getSign() {
		return ("*");
	}
	
	/* (non-Javadoc)
	 * @see org.olga.rebus.structure.relations.AbstractRelation#getThird(int, int, int, int)
	 */
	public int getThird(int w1, int w2, int val1, int val2) {
		if (w1 == 1) {
			if (w2 == 2) {
				return val1 * val2;
			} 
		} 
		if (val1 == 0) {
			return 0;
		}
		if ((val2 % val1) == 0) {
			return val2 / val1;
		} else {
			return -1;
		}
	}
}