package org.olga.rebus.tests;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import org.olga.rebus.calculations.RebusEnumerator;
import org.olga.rebus.io.RebusReader;
import org.olga.rebus.structure.IRebus;
import org.olga.test.FileComparator;
import org.olga.test.ITest;

public class Test27 implements ITest {

	public String name() {
		
		return "27.   rebus_9.rbs";
	}

	public boolean run() {
		RebusReader rr = new RebusReader();
		
		IRebus rebus = rr.read(new File("org/olga/rebus/tests/rebus_10.rbs"));
		
		RebusEnumerator e = new RebusEnumerator(rebus);		
		e.calculate();
		
		try {
			File f = new File("org/olga/rebus/tests/test27-2.txt");
			PrintWriter out = new PrintWriter(new FileWriter(f));
			out.println(e.getResults());
			out.close();
		} catch (IOException e1) {
			System.out.println(e1.getMessage());
		}
		FileComparator fc = new FileComparator("org/olga/rebus/tests/test27-1.txt", "org/olga/rebus/tests/test27-2.txt");
		return fc.compare();
	}
	
}