package org.olga.rebus.tests;

import org.olga.rebus.calculations.Context;
import org.olga.rebus.structure.*;
import org.olga.test.ITest;

/**
 * ,      
 * .
 * 
 * @author Olga
 *
 */
public class Test8 implements ITest {

	public String name() {
		return "8. Calculation of word's value";
	}

	public boolean run() {
		AbstractSymbol[] word = new AbstractSymbol[5];
		word[0] = Rebus.createLetterSymbol("");
		word[1] = Rebus.createLetterSymbol("");
		word[2] = Rebus.createLetterSymbol("");
		word[3] = Rebus.createLetterSymbol("");
		word[4] = Rebus.createNumberSymbol(3);
		AbstractWord rebus = Rebus.createWord(word);
		
		Context ctx = new Context();
		ctx.addSymbol(word[0], 9);
		ctx.addSymbol(word[1], 8);
		ctx.addSymbol(word[2], 7);
		ctx.addSymbol(word[3], 6);
		return rebus.getValue(ctx) == 98763;
	}

}
