package org.olga.rebus.structure;

/**
 *  -.   AbstractRelation.
 * 
 * @author Olga
 * @see AbstractRelation
 *
 */
public class AdditionRelation extends AbstractRelation {

	/**
	 *  .
	 * 
	 * @param op1    .
	 * @param op2    .
	 * @param result    .
	 */
	AdditionRelation(AbstractWord op1, 
			AbstractWord op2, AbstractWord result) {
		super(op1, op2, result);
	}
	
	/* (non-Javadoc)
	 * @see org.olga.rebus.structure.AbstractRelation#getSign()
	 */
	public String getSign() {
		return ("+");
	}
	
	/* (non-Javadoc)
	 * @see org.olga.rebus.structure.relations.AbstractRelation#getThird(int, int, int, int)
	 */
	public int getThird(int w1, int w2, int val1, int val2) {
		if (w1 == 1) {
			if (w2 == 2) {
				return val1 + val2;
			} 
		} 
		return val2 - val1;
	}
}